#include "myutils.h"
#include "alpha3.h"

// [0] = AST
// [1] = C
// [2] = DHN
// [3] = EKQR
// [4] = FWY
// [5] = G
// [6] = ILMV
// [7] = P
byte g_CharToLetterSEB8[256] =
	{
	INVALID_LETTER,	// [  0] 00
	INVALID_LETTER,	// [  1] 01
	INVALID_LETTER,	// [  2] 02
	INVALID_LETTER,	// [  3] 03
	INVALID_LETTER,	// [  4] 04
	INVALID_LETTER,	// [  5] 05
	INVALID_LETTER,	// [  6] 06
	INVALID_LETTER,	// [  7] 07
	INVALID_LETTER,	// [  8] 08
	INVALID_LETTER,	// [  9] 09
	INVALID_LETTER,	// [ 10] 0a
	INVALID_LETTER,	// [ 11] 0b
	INVALID_LETTER,	// [ 12] 0c
	INVALID_LETTER,	// [ 13] 0d
	INVALID_LETTER,	// [ 14] 0e
	INVALID_LETTER,	// [ 15] 0f
	INVALID_LETTER,	// [ 16] 10
	INVALID_LETTER,	// [ 17] 11
	INVALID_LETTER,	// [ 18] 12
	INVALID_LETTER,	// [ 19] 13
	INVALID_LETTER,	// [ 20] 14
	INVALID_LETTER,	// [ 21] 15
	INVALID_LETTER,	// [ 22] 16
	INVALID_LETTER,	// [ 23] 17
	INVALID_LETTER,	// [ 24] 18
	INVALID_LETTER,	// [ 25] 19
	INVALID_LETTER,	// [ 26] 1a
	INVALID_LETTER,	// [ 27] 1b
	INVALID_LETTER,	// [ 28] 1c
	INVALID_LETTER,	// [ 29] 1d
	INVALID_LETTER,	// [ 30] 1e
	INVALID_LETTER,	// [ 31] 1f
	INVALID_LETTER,	// [ 32] 20 ' '
	INVALID_LETTER,	// [ 33] 21 '!'
	INVALID_LETTER,	// [ 34] 22 '"'
	INVALID_LETTER,	// [ 35] 23 '#'
	INVALID_LETTER,	// [ 36] 24 '$'
	INVALID_LETTER,	// [ 37] 25 '%'
	INVALID_LETTER,	// [ 38] 26 '&'
	INVALID_LETTER,	// [ 39] 27 '''
	INVALID_LETTER,	// [ 40] 28 '('
	INVALID_LETTER,	// [ 41] 29 ')'
	INVALID_LETTER,	// [ 42] 2a '*'
	INVALID_LETTER,	// [ 43] 2b '+'
	INVALID_LETTER,	// [ 44] 2c ','
	INVALID_LETTER,	// [ 45] 2d '-'
	INVALID_LETTER,	// [ 46] 2e '.'
	INVALID_LETTER,	// [ 47] 2f '/'
	INVALID_LETTER,	// [ 48] 30 '0'
	INVALID_LETTER,	// [ 49] 31 '1'
	INVALID_LETTER,	// [ 50] 32 '2'
	INVALID_LETTER,	// [ 51] 33 '3'
	INVALID_LETTER,	// [ 52] 34 '4'
	INVALID_LETTER,	// [ 53] 35 '5'
	INVALID_LETTER,	// [ 54] 36 '6'
	INVALID_LETTER,	// [ 55] 37 '7'
	INVALID_LETTER,	// [ 56] 38 '8'
	INVALID_LETTER,	// [ 57] 39 '9'
	INVALID_LETTER,	// [ 58] 3a ':'
	INVALID_LETTER,	// [ 59] 3b ';'
	INVALID_LETTER,	// [ 60] 3c '<'
	INVALID_LETTER,	// [ 61] 3d '='
	INVALID_LETTER,	// [ 62] 3e '>'
	INVALID_LETTER,	// [ 63] 3f '?'
	INVALID_LETTER,	// [ 64] 40 '@'
	0,	// [ 65] 41 A {AST}
	INVALID_LETTER,	// [ 66] 42 'B'
	1,	// [ 67] 43 C {C}
	2,	// [ 68] 44 D {DHN}
	3,	// [ 69] 45 E {EKQR}
	4,	// [ 70] 46 F {FWY}
	5,	// [ 71] 47 G {G}
	2,	// [ 72] 48 H {DHN}
	6,	// [ 73] 49 I {ILMV}
	INVALID_LETTER,	// [ 74] 4a 'J'
	3,	// [ 75] 4b K {EKQR}
	6,	// [ 76] 4c L {ILMV}
	6,	// [ 77] 4d M {ILMV}
	2,	// [ 78] 4e N {DHN}
	INVALID_LETTER,	// [ 79] 4f 'O'
	7,	// [ 80] 50 P {P}
	3,	// [ 81] 51 Q {EKQR}
	3,	// [ 82] 52 R {EKQR}
	0,	// [ 83] 53 S {AST}
	0,	// [ 84] 54 T {AST}
	INVALID_LETTER,	// [ 85] 55 'U'
	6,	// [ 86] 56 V {ILMV}
	4,	// [ 87] 57 W {FWY}
	INVALID_LETTER,	// [ 88] 58 'X'
	4,	// [ 89] 59 Y {FWY}
	INVALID_LETTER,	// [ 90] 5a 'Z'
	INVALID_LETTER,	// [ 91] 5b '['
	INVALID_LETTER,	// [ 92] 5c '\'
	INVALID_LETTER,	// [ 93] 5d ']'
	INVALID_LETTER,	// [ 94] 5e '^'
	INVALID_LETTER,	// [ 95] 5f '_'
	INVALID_LETTER,	// [ 96] 60 '`'
	INVALID_LETTER,	// [ 97] 61 'a'
	INVALID_LETTER,	// [ 98] 62 'b'
	INVALID_LETTER,	// [ 99] 63 'c'
	INVALID_LETTER,	// [100] 64 'd'
	INVALID_LETTER,	// [101] 65 'e'
	INVALID_LETTER,	// [102] 66 'f'
	INVALID_LETTER,	// [103] 67 'g'
	INVALID_LETTER,	// [104] 68 'h'
	INVALID_LETTER,	// [105] 69 'i'
	INVALID_LETTER,	// [106] 6a 'j'
	INVALID_LETTER,	// [107] 6b 'k'
	INVALID_LETTER,	// [108] 6c 'l'
	INVALID_LETTER,	// [109] 6d 'm'
	INVALID_LETTER,	// [110] 6e 'n'
	INVALID_LETTER,	// [111] 6f 'o'
	INVALID_LETTER,	// [112] 70 'p'
	INVALID_LETTER,	// [113] 71 'q'
	INVALID_LETTER,	// [114] 72 'r'
	INVALID_LETTER,	// [115] 73 's'
	INVALID_LETTER,	// [116] 74 't'
	INVALID_LETTER,	// [117] 75 'u'
	INVALID_LETTER,	// [118] 76 'v'
	INVALID_LETTER,	// [119] 77 'w'
	INVALID_LETTER,	// [120] 78 'x'
	INVALID_LETTER,	// [121] 79 'y'
	INVALID_LETTER,	// [122] 7a 'z'
	INVALID_LETTER,	// [123] 7b '{'
	INVALID_LETTER,	// [124] 7c '|'
	INVALID_LETTER,	// [125] 7d '}'
	INVALID_LETTER,	// [126] 7e '~'
	INVALID_LETTER,	// [127] 7f
	INVALID_LETTER,	// [128] 80
	INVALID_LETTER,	// [129] 81
	INVALID_LETTER,	// [130] 82
	INVALID_LETTER,	// [131] 83
	INVALID_LETTER,	// [132] 84
	INVALID_LETTER,	// [133] 85
	INVALID_LETTER,	// [134] 86
	INVALID_LETTER,	// [135] 87
	INVALID_LETTER,	// [136] 88
	INVALID_LETTER,	// [137] 89
	INVALID_LETTER,	// [138] 8a
	INVALID_LETTER,	// [139] 8b
	INVALID_LETTER,	// [140] 8c
	INVALID_LETTER,	// [141] 8d
	INVALID_LETTER,	// [142] 8e
	INVALID_LETTER,	// [143] 8f
	INVALID_LETTER,	// [144] 90
	INVALID_LETTER,	// [145] 91
	INVALID_LETTER,	// [146] 92
	INVALID_LETTER,	// [147] 93
	INVALID_LETTER,	// [148] 94
	INVALID_LETTER,	// [149] 95
	INVALID_LETTER,	// [150] 96
	INVALID_LETTER,	// [151] 97
	INVALID_LETTER,	// [152] 98
	INVALID_LETTER,	// [153] 99
	INVALID_LETTER,	// [154] 9a
	INVALID_LETTER,	// [155] 9b
	INVALID_LETTER,	// [156] 9c
	INVALID_LETTER,	// [157] 9d
	INVALID_LETTER,	// [158] 9e
	INVALID_LETTER,	// [159] 9f
	INVALID_LETTER,	// [160] a0
	INVALID_LETTER,	// [161] a1
	INVALID_LETTER,	// [162] a2
	INVALID_LETTER,	// [163] a3
	INVALID_LETTER,	// [164] a4
	INVALID_LETTER,	// [165] a5
	INVALID_LETTER,	// [166] a6
	INVALID_LETTER,	// [167] a7
	INVALID_LETTER,	// [168] a8
	INVALID_LETTER,	// [169] a9
	INVALID_LETTER,	// [170] aa
	INVALID_LETTER,	// [171] ab
	INVALID_LETTER,	// [172] ac
	INVALID_LETTER,	// [173] ad
	INVALID_LETTER,	// [174] ae
	INVALID_LETTER,	// [175] af
	INVALID_LETTER,	// [176] b0
	INVALID_LETTER,	// [177] b1
	INVALID_LETTER,	// [178] b2
	INVALID_LETTER,	// [179] b3
	INVALID_LETTER,	// [180] b4
	INVALID_LETTER,	// [181] b5
	INVALID_LETTER,	// [182] b6
	INVALID_LETTER,	// [183] b7
	INVALID_LETTER,	// [184] b8
	INVALID_LETTER,	// [185] b9
	INVALID_LETTER,	// [186] ba
	INVALID_LETTER,	// [187] bb
	INVALID_LETTER,	// [188] bc
	INVALID_LETTER,	// [189] bd
	INVALID_LETTER,	// [190] be
	INVALID_LETTER,	// [191] bf
	INVALID_LETTER,	// [192] c0
	INVALID_LETTER,	// [193] c1
	INVALID_LETTER,	// [194] c2
	INVALID_LETTER,	// [195] c3
	INVALID_LETTER,	// [196] c4
	INVALID_LETTER,	// [197] c5
	INVALID_LETTER,	// [198] c6
	INVALID_LETTER,	// [199] c7
	INVALID_LETTER,	// [200] c8
	INVALID_LETTER,	// [201] c9
	INVALID_LETTER,	// [202] ca
	INVALID_LETTER,	// [203] cb
	INVALID_LETTER,	// [204] cc
	INVALID_LETTER,	// [205] cd
	INVALID_LETTER,	// [206] ce
	INVALID_LETTER,	// [207] cf
	INVALID_LETTER,	// [208] d0
	INVALID_LETTER,	// [209] d1
	INVALID_LETTER,	// [210] d2
	INVALID_LETTER,	// [211] d3
	INVALID_LETTER,	// [212] d4
	INVALID_LETTER,	// [213] d5
	INVALID_LETTER,	// [214] d6
	INVALID_LETTER,	// [215] d7
	INVALID_LETTER,	// [216] d8
	INVALID_LETTER,	// [217] d9
	INVALID_LETTER,	// [218] da
	INVALID_LETTER,	// [219] db
	INVALID_LETTER,	// [220] dc
	INVALID_LETTER,	// [221] dd
	INVALID_LETTER,	// [222] de
	INVALID_LETTER,	// [223] df
	INVALID_LETTER,	// [224] e0
	INVALID_LETTER,	// [225] e1
	INVALID_LETTER,	// [226] e2
	INVALID_LETTER,	// [227] e3
	INVALID_LETTER,	// [228] e4
	INVALID_LETTER,	// [229] e5
	INVALID_LETTER,	// [230] e6
	INVALID_LETTER,	// [231] e7
	INVALID_LETTER,	// [232] e8
	INVALID_LETTER,	// [233] e9
	INVALID_LETTER,	// [234] ea
	INVALID_LETTER,	// [235] eb
	INVALID_LETTER,	// [236] ec
	INVALID_LETTER,	// [237] ed
	INVALID_LETTER,	// [238] ee
	INVALID_LETTER,	// [239] ef
	INVALID_LETTER,	// [240] f0
	INVALID_LETTER,	// [241] f1
	INVALID_LETTER,	// [242] f2
	INVALID_LETTER,	// [243] f3
	INVALID_LETTER,	// [244] f4
	INVALID_LETTER,	// [245] f5
	INVALID_LETTER,	// [246] f6
	INVALID_LETTER,	// [247] f7
	INVALID_LETTER,	// [248] f8
	INVALID_LETTER,	// [249] f9
	INVALID_LETTER,	// [250] fa
	INVALID_LETTER,	// [251] fb
	INVALID_LETTER,	// [252] fc
	INVALID_LETTER,	// [253] fd
	INVALID_LETTER,	// [254] fe
	INVALID_LETTER,	// [255] ff
	};
